diff --git a/tools/apply-test.sh b/tools/apply-test.sh
index 4d41a7e672..3231300c6d 100755
--- a/tools/apply-test.sh
+++ b/tools/apply-test.sh
@@ -15,7 +15,7 @@
 # under the License.
 
 ROOT=$(readlink -fn $(dirname $0)/..)
-MODULE_PATH="${ROOT}/modules:/etc/puppet/modules"
+export MODULE_PATH="${ROOT}/modules:/etc/puppet/modules"
 
 export PUPPET_INTEGRATION_TEST=1
 
@@ -104,4 +104,6 @@ echo "Running apply test on these hosts:"
 find applytest -name 'puppetapplytest*.final' -print0
 find applytest -name 'puppetapplytest*.final' -print0 | \
     xargs -0 -P $(nproc) -n 1 -I filearg \
-        sudo puppet apply --modulepath=${MODULE_PATH} --color=false --noop --verbose --debug filearg > /dev/null
+        ./tools/test_puppet_apply.sh filearg
+
+cat applytest/*.out
diff --git a/tools/test_puppet_apply.sh b/tools/test_puppet_apply.sh
new file mode 100755
index 0000000000..ec15a45d12
--- /dev/null
+++ b/tools/test_puppet_apply.sh
@@ -0,0 +1,23 @@
+#!/bin/bash -eux
+
+# Copyright 2015 Hewlett-Packard Development Company, L.P.
+#
+# Licensed under the Apache License, Version 2.0 (the "License"); you may
+# not use this file except in compliance with the License. You may obtain
+# a copy of the License at
+#
+#      http://www.apache.org/licenses/LICENSE-2.0
+#
+# Unless required by applicable law or agreed to in writing, software
+# distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
+# WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
+# License for the specific language governing permissions and limitations
+# under the License.
+
+file=$1
+fileout=${file}.out
+echo "##" > $fileout
+cat $file > $fileout
+sudo puppet apply --modulepath=${MODULE_PATH} --color=false --noop --verbose --debug $file >/dev/null 2>> $fileout
+ret=$?
+exit $ret